﻿using System;
using System.Windows.Media;
using Styx.Common;
using Styx.CommonBot;
using Styx.Common.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.TreeSharp;
using Styx.Common.Helpers;
using Styx.WoWInternals.World;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx;
using System.Linq;

namespace MakeMeSkelly
{
    public class MakeMeSkelly : HBPlugin
    {

       
        

        #region PluginDetails Name/Author/Version
        public override string Name { get { return Constants.PLUGINNAME; } }
        public override string Author { get { return Constants.AUTHOR; } }
        public override Version Version { get { return new Version(1, 0, 0, 0); } }
        #endregion

        #region Local Variables
        private static LocalPlayer Me { get { return StyxWoW.Me; } }  // The Char
        private static bool UseNoggenfogger = true; 
        private WaitTimer wait = WaitTimer.FiveSeconds; // Wait Timer 5 secs for waiting after buff runs out (looks more like a human)
        private static Elixir[] MyElixirs = new[]
        {
            new Elixir { Name = Constants.ELIXIRNAME, ItemID = Constants.ELIXIRID, AuraID = Constants.AURAID },
        };
        #endregion

        public MakeMeSkelly()
        {}

        public static bool IsViable(WoWObject myObject)
        {
            return ((Me != null) && Me.IsValid && StyxWoW.IsInGame && StyxWoW.IsInWorld);
        }

        public void UseElixir(string elixirName)
        {
            int ElixirID = (from elixir in MyElixirs where elixir.Name == elixirName select elixir.ItemID).First();
            int ElixirAura = (from elixir in MyElixirs where elixir.Name == elixirName select elixir.AuraID).First();

            WoWItem TheElixir = StyxWoW.Me.BagItems.FirstOrDefault(item => item.Entry == ElixirID);

            if (TheElixir != null && !Me.HasAura(ElixirAura) && TheElixir.CooldownTimeLeft == TimeSpan.Zero)
            {
                if(wait.IsFinished)
                {
                    TheElixir.Use();
                    wait.Reset();
                }
            }
        }


        public override void Initialize()
        {
            base.Initialize();
            Logging.Write(System.Windows.Media.Colors.Red, Constants.PLUGINENABLED); 
        }

        
        public override void Dispose()
        {
            Logging.Write(System.Windows.Media.Colors.Red, Constants.PLUGINDISABLED);

            BotEvents.OnBotStart -= OnBotStartHandler;
            BotEvents.OnBotStop -= OnBotStopHandler;

            base.Dispose();
        }

        public override void Pulse()
        {

            if (!IsViable(Me) || Me.Mounted || Me.IsOnTransport || Me.IsResting || Me.IsDead)
            {
                // Logging.Write(System.Windows.Media.Colors.White, "UPPER IF"); Debugging Use Only
                return;
            }

            if (UseNoggenfogger) {
                // Logging.Write(System.Windows.Media.Colors.White, "DOWN IF"); Debugging Use Only
                UseElixir(Constants.ELIXIRNAME); 
            }
        }

        #region Bot Start & Stop Handler
        public void OnBotStartHandler(EventArgs args)
        {
        }

        public void OnBotStopHandler(EventArgs args)
        {
        }
        #endregion
    }
}
